const ini = require('ini'),
    os = require('os'),
    fs = require('fs');

const packageConfig = require('../package.json').config;

const __configDir = `${os.homedir()}/.config/lektor`;
const __configFile = `${__configDir}/amadeus.ini`;
const __configLektord = `${__configDir}/lektor.ini`;

fs.mkdirSync(__configDir, { recursive: true });
__dir = fs.opendirSync(__configDir);
__dir.close(err => {
    if (err) throw err;
});

var config = {
    file: __configFile,
    content: null,
    reload() {
        var fd = fs.openSync(__configFile, 'a');
        fs.close(fd, err => {});
        this.content = ini.parse(fs.readFileSync(__configFile, 'utf-8'));

        this.content.database ??= {};
        this.content.lektord ??= {};
        this.content.kurisu ??= {};
        this.content.client ??= {};
        this.content.log ??= {};

        this.content.kurisu.url ??= packageConfig.kurisu;
        this.content.client.port ??= packageConfig.port;
        this.content.log.level ??= 'debug';
        this.content.log.lektord ??= true;
        this.content.database.path ??= '/home/kara/kara.db';
        this.content.lektord.host ??= 'localhost';
        this.content.lektord.port ??= '6600';
        this.content.lektord.attach ??= true;

        fs.writeFileSync(__configFile, ini.stringify(this.content));

        this.flush();
    },
    flush() {
        fs.writeFileSync(__configFile, ini.stringify(this.content));
    },
};

config.reload();
module.exports = global.config = module.exports = config;
