/* The log window */

const { ipcRenderer } = require('electron'),
    logger = require('../common/logger.js'),
    ejs = require('ejs'),
    e = require('express'),
    fs = require('fs'),
    readline = require('readline'),
    Tail = require('tail').Tail;

var file = new Tail(logger.logfile, { fromBeginning: false, follow: true, nLines: 100 });

file.on('line', line => {
    const regexp = /^\[[^ ]+([^\]]+)\] ([^ ]+) +([^ ]+) +\| +(.*)$/;
    const match = line.match(regexp).slice(1);
    $('#body').append(
        `<tr ${
            match[1] === 'error'
                ? 'class="table-danger"'
                : match[1] === 'warn'
                ? 'class="table-warning"'
                : match[1] === 'info'
                ? 'class="table-info"'
                : ''
        }>
            <td>${match[0]}</td>
            <td>${match[2]}</td>
            <td>${match[3]}</td>
        </tr>`
    );

    const limit = 200;
    var trs = $('tr');
    if (trs.length > limit) trs.slice(2, trs.length - limit).remove();
    window.scrollTo(0, document.body.scrollHeight);
});

window.onload = () => {};
